/**
	$Id$

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.migrate;

import java.io.Writer;
import java.sql.ResultSet;


/**
	Abstract base implementation of a result writer that simply
	store the result set, writer, etc. that are needed later.
	Subclasses have read access to the instance variables directly.
	
	@author Nicklas
	@since 3.1
	@base.modified $Date: 2011-11-30 11:58:08 +0100 (on, 30 nov 2011) $
*/
public abstract class AbstractResultWriter
	implements ResultWriter
{
	
	protected final char[] NULL_ESCAPE;
	protected final ResultSet rs;
	protected final int index;
	protected final Writer writer;
	
	/**
		Creates a new writer. 
		@param nullEscape The character sequence to write for null values
	*/
	protected AbstractResultWriter(ResultSet rs, int index, Writer writer, char[] nullEscape)
	{
		this.rs = rs;
		this.index = index;
		this.writer = writer;
		this.NULL_ESCAPE = nullEscape;
	}
	
}
