/**
	$Id: NumberFormatUtil.java 4515 2008-09-11 20:08:14Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util;

import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

/**
 	Utility class for working with {@link java.text.NumberFormat} object.

	@author nicklas
	@version 2.2
	@base.modified $Date: 2008-09-11 22:08:14 +0200 (Thu, 11 Sep 2008) $
*/
public class NumberFormatUtil
{

	public static java.text.NumberFormat 
		getNumberFormat(char decimalSeparator, char groupingSeparator)
	{
		DecimalFormatSymbols sym = new DecimalFormatSymbols();
		sym.setDecimalSeparator(decimalSeparator);
		sym.setGroupingSeparator(groupingSeparator);
		DecimalFormat df = new DecimalFormat("0.#", sym);
		df.setParseIntegerOnly(false);
		return df;
	}
	
}
