/**
	$Id: PathType.java 5482 2010-11-10 11:16:51Z nicklas $

	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions.xml;

/**
	Specify the type of paths. It is used
	by the {@link PathSetter} annotation and {@link PathConverter}.

	@author Nicklas
	@since 2.17
	@base.modified $Date: 2010-11-10 12:16:51 +0100 (Wed, 10 Nov 2010) $
*/
public enum PathType
{
	
	/**
		Paths should be absolute paths from the root of the web server.
	*/
	ABSOLUTE,
	
	/**
		Paths should be relative to the web application context. The difference
		is usually that the first part of the absolute path is missing.
	*/
	CONTEXT_RELATIVE;
	
	
}
