/**
	$Id: DataFileTypeInfo.java 4512 2008-09-11 20:05:50Z jari $

	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.info;

import java.io.Serializable;


/**
 	This holds information about a DataFileType in BASE.
 	It can be used to send information about this kind of item
 	over web services.
 	@see net.sf.basedb.core.DataFileType
  	@author Martin
  	@version 2.5
 	
 */
public class DataFileTypeInfo 
	extends BasicItemInfo
		implements NameableInfo, Serializable
{
	private static final long serialVersionUID = 4331580958109079719L;
	private String externalId = null;
	private String extension = null;
	private String name = null;
	private String description = null;
	
	/**
	 	
	 */
	public DataFileTypeInfo()
	{
		super();
	}
	
	/**	
	  	@param externalId The externalId to set.
	*/
	public void setExternalId(String externalId)
	{
		this.externalId = externalId;
	}

	/**	
	 	@return Returns the externalId.
	*/
	public String getExternalId()
	{
		return externalId;
	}

	/**	
	  	@param extension The extension to set.
	*/
	public void setExtension(String extension)
	{
		this.extension = extension;
	}

	/**	
	 	@return Returns the extension.
	*/
	public String getExtension()
	{
		return extension;
	}

	/**	
	  	@param description The description to set.
	*/
	public void setDescription(String description)
	{
		this.description = description;
	}

	/**	
	 	@return Returns the description.
	*/
	public String getDescription()
	{
		return description;
	}

	/**	
	  	@param name The name to set.
	*/
	public void setName(String name)
	{
		this.name = name;
	}

	/**	
	 	@return Returns the name.
	*/
	public String getName()
	{
		return name;
	}
}