<%-- $Id: edit_category.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Dominic Oyeniran

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Dominic
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ANNOTATIONTYPECATEGORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	AnnotationTypeCategory annotationTypeCategory = null;

	
	if (itemId == 0)
	{
		//to create a new annotation category
		title = "Create annotation type category";
		cc.removeObject("item");
	}
	else
	{
		//if user click on edit, to edit annotationcategory
		annotationTypeCategory = AnnotationTypeCategory.getById(dc, itemId);
		cc.setObject("item", annotationTypeCategory);
		title = "Edit annotation type category-- " + HTML.encodeTags(annotationTypeCategory.getName());
		annotationTypeCategory.checkPermission(Permission.WRITE);
	}
	
	// ---- Query to retrieve annotationtype members for a category
	ItemQuery<AnnotationType> annotationTypeQuery = null;
	if (annotationTypeCategory != null)
	{
		annotationTypeQuery = annotationTypeCategory.getAnnotationTypes(null);
		annotationTypeQuery.include(Include.ALL);
		annotationTypeQuery.order(Orders.asc(Hql.property("name")));
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), annotationTypeCategory);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,linkitems.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Annotation type category" tab
		function validateAnnotationTypeCategory()
		{
			var frm = document.forms['annotationTypeCategory'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		
		// Validate the "Members" tab
		function validateMembers()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['annotationTypeCategory'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.addAnnotationTypes.value = Link.getActionIds(1, 'Z').join(',');
				frm.removeAnnotationTypes.value = Link.getActionIds(-1, 'Z').join(',');				
				frm.submit();
			}
		}
		// Initialise edit_category web interface		
		
		function init()
		{
			<%
			if (annotationTypeCategory == null)
			{
				%>
				var frm = document.forms['annotationTypeCategory'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initMembers();
		}
		
		function initMembers()
		{
			var members = document.forms['annotationTypeCategory'].members;
			<%
			if (annotationTypeQuery != null)
			{
				ItemResultList<AnnotationType> annotationTypes = annotationTypeQuery.list(dc);
				for (AnnotationType annotationType : annotationTypes)
				{
					%>
					Link.addNewItem(members, new Item('Z', <%=annotationType.getId()%>, '<%=HTML.javaScriptEncode(annotationType.getName())%>'));
					<%
				}
			}
			%>
		}
		function addAnnotationTypesOnClick()
		{
			var annotationtypes = Link.getListIds(document.forms['annotationTypeCategory'].members, 'Z');
			var url = '../annotationtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAnnotationTypeCallback';
			url += '&exclude='+annotationtypes.join(',');
			Main.openPopup(url, 'AddAnnotationTypes', 1050, 700);
		}
		
		function addAnnotationTypeCallback(annotationTypeId, name)
		{
			var item = Link.getItem('Z', annotationTypeId);
			if (!item) item = new Item('Z', annotationTypeId, name);
			Link.addItem(document.forms['annotationTypeCategory'].members, item);
		}
		function removeOnClick()
		{
			Link.removeSelected(document.forms['annotationTypeCategory'].members);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="annotationTypeCategory" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol"
			position="bottom"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Annotation type category" validate="validateAnnotationTypeCategory()"
			helpid="annotationtypecategory.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(annotationTypeCategory == null ? Values.getString(cc.getPropertyValue("name"), "New annotation type category") : annotationTypeCategory.getName())%>" 
					maxlength="<%=AnnotationTypeCategory.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(annotationTypeCategory == null ? cc.getPropertyValue("description") : annotationTypeCategory.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'annotationTypeCategory', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="members" title="Annotation types" tooltip="Add/remove members of this category" 
			validate="validateMembers()" helpid="annotationtypecategory.edit.members">
			<table class="fullform input100">
			<tr class="dynamic">
				<th>Annotation types</th>
				<td>
					<div class="selectionlist">
						<table>
						<tr>
							<td>
								<select name="members" size="14" multiple>
								</select>
								<input type="hidden" name="removeAnnotationTypes" value="">
								<input type="hidden" name="addAnnotationTypes" value="">
							</td>
							<td style="vertical-align: top;">
								<base:buttongroup vertical="true">
									<base:button 
										subclass="leftaligned"
										onclick="addAnnotationTypesOnClick()" 
										title="Add&nbsp;annotation&nbsp;types&hellip;" 
										tooltip="Add annotation types to this category"
									/>
									<base:button 
										subclass="leftaligned"
										onclick="removeOnClick()" 
										title="Remove" 
										tooltip="Remove the selected items from this category"
									/>
								</base:buttongroup>
							</td>
						</tr>
						</table>
					</div>
				</td>
			</tr>
			</table>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
