<%-- $Id: edit_protocol.jsp 5964 2012-02-15 13:59:24Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.PROTOCOL;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Protocol protocol = null;
	boolean readCurrentSubtype = true;
	int currentSubtypeId = 0;
	boolean readCurrentFile = true;
	File currentFile = null;
	ItemQuery<AnnotationType> parameterQuery = null;

	// Load recently used items
	List<File> recentFiles = (List<File>)cc.getRecent(dc, Item.FILE);

	if (itemId == 0)
	{
		title = "Create protocol";

		currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		if (currentSubtypeId == 0) 
		{
			int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
			currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
		}
		cc.removeObject("item");
	}
	else
	{
		protocol = Protocol.getById(dc, itemId);
		protocol.checkPermission(Permission.WRITE);
		
		parameterQuery = protocol.getParameters();
		cc.setObject("item", protocol);
		title = "Edit protocol -- " + HTML.encodeTags(protocol.getName());
		try
		{
			ItemSubtype subtype = protocol.getItemSubtype();
			if (subtype != null) currentSubtypeId = subtype.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentFile = protocol.getFile();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFile = false;
		}
	}
	
	// Query to retrieve protocol types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), protocol);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js,ajax.js,json2.js,subtypes.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Protocol" tab
		function validateProtocol()
		{
			var frm = document.forms['protocol'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Validate the "Parameters" tab
		function validateParameters()
		{
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['protocol'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				frm.addedAnnotationTypes.value = Link.getActionIds(1, 'A').join(',');
				frm.removedAnnotationTypes.value = Link.getActionIds(-1, 'A').join(',');
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
					annotationsLoaded = true;
				}
			}
		}
		
		function browseOnClick()
		{
			var frm = document.forms['protocol'];
			var subtype = Math.abs(frm.subtype_id[frm.subtype_id.selectedIndex].value);
			var relatedFileSubtype = ItemSubtype.getRelatedSubtype(subtype, 'FILE', <%=SystemItems.getId(File.PROTOCOL)%>);
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&title=Select+protocol+file&callback=setFileCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemSubtype=' + relatedFileSubtype.id;
			if (frm.file_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.file_id[1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectFile', 1050, 700);
		}
		function setFileCallback(id, path)
		{
			var frm = document.forms['protocol'];
			var list = frm.file_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = path;
			list.selectedIndex = 1;
		}

		function init()
		{
			var frm = document.forms['protocol'];
			<%
			if (protocol == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			if (parameterQuery != null)
			{
				%>
				var annotationTypes = frm.annotationTypes;
				<%
				parameterQuery.include(Include.ALL);
				parameterQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<AnnotationType> parameters = parameterQuery.list(dc);
				for (AnnotationType at : parameters)
				{
					%>
					Link.addNewItem(annotationTypes, new Item('A', <%=at.getId()%>, '<%=HTML.javaScriptEncode(at.getName())%>'));
					<%
				}
			}
			%>
		}
		function addAnnotationTypesOnClick()
		{
			var frm = document.forms['protocol'];
			var ids = Link.getListIds(frm.annotationTypes, 'A');
			var excludes = ids.join(',');
			var url = '../annotationtypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addAnnotationTypeCallback';
			url += '&resetTemporary=1&tmpfilter:BOOLEAN:protocolParameter=true';
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddAnnotationTypes', 1050, 700);
		}
		function addAnnotationTypeCallback(annotationTypeId, name)
		{
			var item = Link.getItem('A', annotationTypeId);
			if (!item) item = new Item('A', annotationTypeId, name);
			Link.addItem(document.forms['protocol'].annotationTypes, item);
		}
		function removeAnnotationTypesOnClick()
		{
			Link.removeSelected(document.forms['protocol'].annotationTypes);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="protocol" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=protocol != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Protocol" validate="validateProtocol()" helpid="protocol.edit">
			<table class="fullform input100 smaller">
			<tr>
				<th>Name</th>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(protocol == null ? Values.getString(cc.getPropertyValue("name"), "New protocol") : protocol.getName())%>" 
					maxlength="<%=Protocol.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id" 
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && protocol != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(protocol == null ? Values.getString(cc.getPropertyValue("externalId"), "") : protocol.getExternalId())%>" 
					maxlength="<%=Protocol.MAX_EXTERNAL_ID_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>File</th>
				<td>
					<base:select 
						id="file_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentFile%>"
						denied="<%=!readCurrentFile%>"
						recent="<%=recentFiles%>"
						newitem="<%=protocol == null%>"
						onselect="browseOnClick()"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea <%=clazz%> rows="6" name="description" 
						><%=HTML.encodeTags(protocol == null ? cc.getPropertyValue("description") : protocol.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon image="zoom.png" 
						onclick="Main.zoom('Description', 'protocol', 'description')"
						tooltip="Edit in larger window"
					/>
				</td>
			</tr>
			<%
			if (sc.getActiveProjectId() != 0 && protocol == null && sc.getActiveProjectPermissions().contains(Permission.WRITE))
			{
				%>
				<tr>
					<th></th>
					<td>
						<input type="checkbox" id="setAsProjectDefault" name="setAsProjectDefault" value="1" 
							checked><label for="setAsProjectDefault">Set as project default</label>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>
		
		<t:tab id="parameters" title="Parameters" 
			validate="validateParameters()" helpid="protocol.edit.parameters">
			<table class="fullform input100">
			<tr class="big">
				<th>Annotation types</th>
				<td>
				<div class="selectionlist">
					<table>
					<tr>
						<td>
						<select name="annotationTypes" size="20" multiple>
						</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									subclass="leftaligned"
									style="width: 15em;"
									onclick="addAnnotationTypesOnClick()" 
									title="Add annotation types&hellip;" 
									tooltip="Add annotation types"
									/>
								<base:button 
									subclass="leftaligned"
									style="width: 15em;"
									onclick="removeAnnotationTypesOnClick()" 
									title="Remove" 
									tooltip="Remove the selected annotation types"
								/>
							</base:buttongroup>
						<input type="hidden" name="addedAnnotationTypes" value="">
						<input type="hidden" name="removedAnnotationTypes" value="">
						</td>
					</tr>
					</table>
				</div>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit"><iframe 
			name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
			style="width: 100%; height: 100%;"></iframe></t:tab>

		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
