<%-- $Id: overview.jsp 5951 2012-02-09 14:19:17Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2009 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.overview.GenericOverview"
	import="net.sf.basedb.util.overview.OverviewUtil"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	BasicItem item = itemType.getById(dc, itemId);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, null, item);
	ExtensionsInvoker invoker = ExtensionsControl.useExtensions(jspContext, 
		"net.sf.basedb.clients.web.toolbar.item.overview");
	final String showFailures = request.getParameter("show_failures");
	%>
	<base:page type="include">
	<base:body>
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function expandAll()
		{
			frames['overview']['tree'].openAll();
		}
		function collapseAll()
		{
			frames['overview']['tree'].closeAll();
		}
		function reset()
		{
			var url = '<%=root%>/common/overview/index.jsp?ID=<%=ID%>';
			url += '&cmd=Overview&forceNew=1';
			url += '&item_type=<%=itemType.name()%>';
			url += '&item_id=<%=itemId%>';
			frames['overview'].location.href = url;
		}
		function validate()
		{	
			var url = '<%=root%>/common/overview/index.jsp?ID=<%=ID%>';
			url += '&cmd=Validate';
			url += '&item_type=<%=itemType.name()%>';
			url += '&item_id=<%=itemId%>';
			frames['overview'].location.href = url;
		}
		function validationOptions()
		{
			frames['overview'].Main.openPopup('<%=root%>/common/overview/options.jsp?ID=<%=ID%>', 'ValidationOptions', 750, 500);
		}
		</script>
			<tbl:toolbar subclass="absolutefull" style="height: 1.75em;">
				<tbl:button image="refresh.png" title="Reset"
					onclick="reset()" tooltip="Unload all cached items and restart from the root item again."
				/>
				<tbl:button image="validate.png" title="Validate" 
					onclick="validate()" tooltip="Load and validate entire tree" 
				/>
				<tbl:button image="configure.png" title="Validation options&hellip;" 
					onclick="validationOptions()" tooltip="Change validation options"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				<tbl:button image="help.png" title="Help&hellip;"
					onclick="<%="Main.openHelp('" + ID +"', 'item.overview')"%>"
					tooltip="Get help about this page"
				/>
			</tbl:toolbar>
			<div class="absolutefull topborder" style="top: 1.75em;"><iframe 
				name="overview" id="idOverview" 
				src="<%=root%>/common/overview/index.jsp?ID=<%=ID%>&cmd=Overview&item_type=<%=itemType.name()%>&item_id=<%=itemId%>" 
				style="width: 100%; height: 100%;"></iframe></div>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
