<%-- $Id: ownership.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2008 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Configure the order and visibility of columns in a table of items.
	This page will use the TableColumn.getTableColumns(item) to retreive the
	list of all available columns for that item type and
	getSession().getSetting(item+".columns") to retreive a comma-separated
	list of the current order of visible columns.

	@author Martin
	@version 2.9
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Collections"
	import="java.util.List"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = sc.getCurrentContext(itemType, subContext);

final DbControl dc = sc.newDbControl();

try
{
	Set<OwnedItem> items = (Set<OwnedItem>)cc.getObject("OwnedItems");
	User defaultOwner = User.getById(dc, sc.getLoggedInUserId());	
	List<User> recentUsers = (List<User>)cc.getRecent(dc, Item.USER);
	
	// Headline on the web page.
	String headLine = null;
	if (items.size() == 1)
	{
		OwnedItem ownedItem = items.iterator().next();
		if (ownedItem instanceof Nameable)
		{
			headLine = "Set owner of -- " + HTML.encodeTags(((Nameable)ownedItem).getName());
		}
		else
		{
			headLine = "Set owner of -- " + HTML.encodeTags(ownedItem.toString()); 
		}		
	}
	else	
	{
		headLine = "Set owner of -- Multiple items ("+items.size()+")";
	}
			
	%>
	<base:page type="popup" title="Set owner">
	<base:head scripts="" >
		<script language="JavaScript">
		function saveSettings()
		{
			var frm = document.forms['ownership'];
			frm.submit();
		}
		function selectOwnerOnClick()
		{
			var frm = document.forms['ownership'];
			var url = '../../admin/users/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setOwnerCallback';
			if (frm.owner_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.owner_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectOwner', 1050, 700);
		}
		function setOwnerCallback(id, name)
		{
			var frm = document.forms['ownership'];
			var list = frm.owner_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		</script>
	</base:head>
	<base:body onload="">
		<h1><%=headLine%> <base:help helpid="ownership.configure" /></h1>
		<form name="ownership" action="submit_ownership.jsp" onsubmit="return false;">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="cmd" value="Save">
			<input type="hidden" name="item_type" value="<%=itemType.name()%>">
			<input type="hidden" name="subcontext" value="<%=subContext%>">
			
			<div class="content" >
				<table class="fullform input100 bottomborder smaller">
					<tr>
						<th>New owner</th>
						<td>
							<base:select 
								id="owner_id"
								clazz="selectionlist"
								required="true"
								current="<%=defaultOwner%>"
								recent="<%=recentUsers%>"
								newitem="true"
								onselect="selectOwnerOnClick()"
							/>
						</td>
					</tr>
					<tr class="dynamic">
						<th></th>
						<td></td>
					</tr>
				</table>
			</div>			
		</form>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings();" title="Ok" />
			<base:button onclick="window.close();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>