<%-- $Id: paste_multiple.jsp 5917 2011-12-19 11:28:45Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
String form = request.getParameter("form");
String prefix = request.getParameter("prefix");
String title = "Paste multiple";
%>

	<base:page type="popup" title="<%=title%>">
	<base:head>
		<script language="JavaScript">
		// Validate the "ArraySlide" tab
		function init()
		{
			var pfrm = window.opener.document.forms['<%=form%>'];
			var frm = document.forms['paste'];
			if (pfrm)
			{
				var i = 0;
				var text = '';
				while (pfrm['<%=prefix%>'+i])
				{
					text += pfrm['<%=prefix%>'+i].value + '\n';
					i++;
				}
				frm['text'].value = text;
			}
		}

		// Submit the form
		function save()
		{
			var pfrm = window.opener.document.forms['<%=form%>'];
			var frm = document.forms['paste'];
			if (pfrm)
			{
				var text = frm['text'].value.split('\n');
				for (var i = 0; i < text.length; ++i)
				{
					var field = '<%=prefix%>' + i;
					if (pfrm[field]) pfrm[field].value = text[i];
				}
				// Clear any remaining fields
				while (pfrm['<%=prefix%>'+i])
				{
					pfrm['<%=prefix%>'+i].value = '';
					i++;
				}
			}
			window.close();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1><%=title%> <base:help helpid="arrayslide.createwizard.pastemultiple" /></h1>
		<form name="paste" onsubmit="return false;">

		<div class="content">
			<table style="width: 100%; height: 100%;">
			<tr>
				<td class="padded filled">
				<i>
					Enter one name or barcode per line. Click <b>Save</b> to store the
					result in the parent form.
				</i>
				</td>
			</tr>
			<tr>
			<td style="height: 98%;">
				<table class="fullcc input100"><tr><td>
				<textarea class="autohight" rows="20"name="text"></textarea>
				</td></tr></table>
			</td>
			</tr>
			</table>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="save()" title="Save" />
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
