<%-- $Id: set_active.jsp 5958 2012-02-14 10:26:51Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.StringUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Arrays"
%>
<%@ taglib
	prefix="base" uri="/WEB-INF/base.tld"
%>
<%
SessionControl sc = Base.getExistingSessionControl(pageContext, true);
String ID = sc.getId();
int projectId = Values.getInt(request.getParameter("project_id"), 0);

String title = "";
String message = "";

DbControl dc = sc.newDbControl();
try
{
	Project p = null;
	ItemContext allItems = sc.getCurrentContext(Item.PROJECT, "items");
	allItems.getInclude().add(Include.MINE);
	if (projectId != 0) 
	{
		p = Project.getById(dc, projectId);
		allItems.getInclude().add(Include.OTHERS);
	}
	sc.setActiveProject(p);
	sc.setUserClientSetting("projects.lastactive", projectId == 0 ? null : Integer.toString(projectId));
	if (projectId != 0)
	{
		String recent = sc.getUserClientSetting("projects.recentActive");
		List<String> recentActive = null;
		if (recent == null)
		{
			recentActive = new ArrayList<String>();
		}
		else
		{
			// Need a new list since Arrays.asList returns a read-only list
			recentActive = new ArrayList<String>(Arrays.asList(recent.split(":")));
		}
		String thisProject = Integer.toString(projectId);
		recentActive.remove(thisProject);
		recentActive.add(0, thisProject);
		int maxRecent = Values.getInt(sc.getUserClientSetting("menu.mostRecent.maxViewed"), 6);
		if (recentActive.size() > maxRecent) recentActive = recentActive.subList(0, maxRecent);
		sc.setUserClientSetting("projects.recentActive", StringUtil.join(recentActive, ":", true));
	}
	sc.setSessionSetting("menu.standard.html", null);
	if (p == null)
	{
		title = "All projects deactivated";
		message = "No active project.";
	}
	else
	{
		title = "Project activated";
		message = "The project <b><i>"+HTML.encodeTags(p.getName())+"</i></b> "+
			"is now the active project.";
	}
}
finally
{
	if (dc != null) dc.close();
}
%>
<base:page type="popup" title="<%=title%>">
<base:head>
<script language="JavaScript">
function reloadAndClose()
{
	window.opener.location.reload();
	setTimeout(closeWindow, 500);
}
function closeWindow()
{
	window.close();
}
</script>
</base:head>
<base:body onload="reloadAndClose()">
	<h1><%=title %></h1>
	<div class="content">
		<table class="fullcc"><tr><td>
		<%=message %>
		</td></tr></table>
	</div>

	<base:buttongroup subclass="dialogbuttons">
		<base:button onclick="window.close();" title="Ok" />
	</base:buttongroup>
</base:body>
</base:page>

