<%-- $Id: jep_extra_value_calculator.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ExtraValueType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"	
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
ItemContext cc = sc.getCurrentContext(Item.BIOASSAYSET);
ItemContext realContext = (ItemContext)sc.getSessionSetting("plugin.configure.currentContext");
if (realContext == null) realContext = cc;
DbControl dc = null;
try
{
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	dc = sc.newDbControl();
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job, false);
	BioAssaySet source = null;
	if (job != null) source = (BioAssaySet)job.getParameterValue("source");
	if (source == null && cc.getId() != 0) source = BioAssaySet.getById(dc, cc.getId());
	if (source == null) throw new WebException("popup", "No current bioassay set", 
		"Could not find any current bioassay set. Please select a bioassay set before trying again");
	source = BioAssaySet.getById(dc, source.getId());
	int maxRawMappings = source.getMaxRawMappingsForSpot();

	RawDataType rdt = source.getRawDataType();
	
	//Find selected bioassays
	List<BioAssay> bioAssays = null;
	if (job != null) bioAssays = (List<BioAssay>)job.getParameterValues("bioAssays");
	if (bioAssays == null)
	{
		ItemContext bioAssayContext = sc.getCurrentContext(Item.BIOASSAY);
		ItemQuery<BioAssay> bioAssayQuery = null;
		if (bioAssayContext.getSelected().size() > 0)
		{
			bioAssayQuery = source.getBioAssays();
			bioAssayQuery.restrict(
				Restrictions.in(Hql.property("id"), Expressions.parameter("selected"))
			);
			bioAssayQuery.setParameter("selected", bioAssayContext.getSelected(), Type.INT);
			bioAssays = bioAssayQuery.list(dc);
		}
	}
	
	// Current parameter values
	ExtraValueType currentExtraValueType = (ExtraValueType)job.getParameterValue("extraValueType");
	String expression = (String)job.getParameterValue("expression");
	
	
	// Predefined formulas
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.COLUMN_EXPRESSION, rdt, 
			source.getIntensityTransform());
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	ItemResultList<Formula> formulas = formulaQuery.list(dc);
	StringBuilder formulaOptions = new StringBuilder();
	for (Formula f : formulas)
	{
		String formula = f.getFormula(0);
		if (maxRawMappings == 1 || !formula.contains("raw("))
		{
			addFormulaOption(formulaOptions, formula, f.getName(), f.getDescription());
		}
	}
	
	// Load recently used items
	List<ExtraValueType> recentExtraValueTypes = (List<ExtraValueType>)realContext.getRecent(dc, Item.EXTRAVALUETYPE);
	%>
	<base:page type="popup" title="Calculate extra value">
	<base:head scripts="linkitems.js" styles="parameters.css">
		<script language="JavaScript">
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}
		function selectExtraValueTypeOnClick()
		{
			var frm = document.forms['extraValue'];
			var url = '../../admin/extravaluetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setExtraValueTypeCallback';
			if (frm['parameter:extraValueType'].length > 1) 
			{
				var id = Math.abs(parseInt(frm['parameter:extraValueType'][1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectExtraValueType', 1050, 700);
		}
		function setExtraValueTypeCallback(id, name)
		{
			var frm = document.forms['extraValue'];
			var list = frm['parameter:extraValueType'];
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		
		function presetOnChange(list, formula, label)
		{
			var index = list.selectedIndex;
			formula.value = list[index].value;
			if (list[index].value != '' && label) label.value = list[index].text;
		}
		function openExpressionBuilder()
		{
			Main.expressionBuilder('<%=ID%>', 'Expression', 'extraValue', 'parameter:expression', 'COLUMN_EXPRESSION', '<%=rdt.getId()%>', <%=rdt.getChannels()%>, false, <%=source.getId()%>);
		}
		function validate()
		{
			var frm = document.forms['extraValue'];
			if (!frm.allBioAssays.checked && frm.bioAssays.length == 0)
			{
				alert('You have not selected any bioassays');
				return false;
			}
			else if (frm['parameter:extraValueType'].selectedIndex < 0)
			{
				alert('You must select a type');
				return false;
			}
			else if (Main.trimString(frm['parameter:expression'].value) == '')
			{
				alert('You must enter an expression for the extra value');
				frm['parameter:expression'].focus();
				return false;
			}
			<%
			if (maxRawMappings != 1)
			{
				%>
				else if (frm['parameter:expression'].value.search(/raw\(/) != -1)
				{
					alert('Can\'t use function raw() for bioassaysets with multiple mappings to raw data');
					frm['parameter:expression'].focus();
					return false;
				}
				<%
			}
			%>
			return true;
		}
		function doNext()
		{
			if (validate())
			{
				var frm = document.forms['extraValue'];
				if (!frm.allBioAssays.checked)
				{
					var ids = Link.getListIds(frm.bioAssays, 'R');
					for (var i = 0; i < ids.length; i++)
					{
						Forms.createHidden(frm, 'parameter:bioAssays', ids[i]);
					}
				}
				frm.submit();
			}
		}		
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		function allBioAssaysOnClick()
		{
			var frm = document.forms['extraValue'];
			frm.bioAssays.disabled = frm.allBioAssays.checked;
		}
		function addBioAssaysOnClick()
		{
			var frm = document.forms['extraValue'];
			frm.allBioAssays.checked = false;
			frm.bioAssays.disabled = false;
			var ids = Link.getListIds(frm.bioAssays, 'R');
			var excludes = ids.join(',');
			var url = '../../views/experiments/bioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addBioAssayCallback&bioassayset_id=<%=source.getId()%>';
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddBioAssays', 1050, 700);
		}
		function addBioAssayCallback(bioAssayId, name)
		{
			var item = Link.getItem('R', bioAssayId);
			if (!item) item = new Item('R', bioAssayId, name);
			Link.addItem(document.forms['extraValue'].bioAssays, item);
		}
		function removeBioAssaysOnClick()
		{
			var frm = document.forms['extraValue'];
			if (frm.allBioAssays.checked)
			{
				return;
			}
			Link.removeSelected(frm.bioAssays);
		}
		function init()
		{
			initBioAssays();
		}
		
		function initBioAssays()
		{
			var frm = document.forms['extraValue'];
			<%
			if (bioAssays != null)
			{
				for (BioAssay ba : bioAssays)
				{
					%>
					Link.addNewItem(frm.bioAssays, new Item('R', <%=ba.getId()%>, '<%=HTML.javaScriptEncode(ba.getName())%>'));
					<%
				}
			}
			%>
			frm.allBioAssays.checked = frm.bioAssays.length == 0;
			allBioAssaysOnClick();
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<h1>Calculate extra value <base:help helpid="jepextravaluecalculator.options"/></h1>
		<form name="extraValue" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="parameter:source" value="<%=source.getId()%>">
		
		<div class="content bottomborder">
			<table class="fullform input100">
			<%
			if (errorMessage != null || (errors != null && errors.size() > 0))
			{
				%>
				<tr>
					<th></th>
					<td colspan="2">
					<div id="errors" style="margin-bottom: 12px;">
						<div class="messagecontainer error" style="margin: 0px;">
						<%=errorMessage %>
						<%
						if (errors != null && errors.size() > 0)
						{
							%>
							<div id="showerrorlist">
								<base:icon image="gonext.png" 
									onclick="showErrorList()" 
									style="color: #FFFFFF;"
									tooltip="Show more information about the error"
								/>
							</div>
							<div id="errorlist" style="display: none; margin: 0px;">
								<base:icon image="move_down.png" 
									onclick="hideErrorList()" 
									style="color: #FFFFFF;" 
									tooltip="Show less information"
								/>
								<ol>
								<%
								for (Throwable t : errors)
								{
									%>
									<li><%=t.getMessage()%>
									<%
								}
								%>
								</ol>
							</div>
							<%
						}
						%>
					</div>
					</td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Source</th>
				<td><%=HTML.encodeTags(source.getName())%></td>
				<td></td>
			</tr>
			<tr class="big">
				<th class="subprompt">Bioassays</th>
				<td>
					<input type="checkbox" name="allBioAssays" id="allBioAssays"
						onclick="allBioAssaysOnClick()"><label for="allBioAssays">All bioassays</label><br>
					<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="bioAssays" size="5" multiple>
							</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									subclass="leftaligned"
									onclick="addBioAssaysOnClick()" 
									title="Add bioassays&hellip;" 
									tooltip="Add bioassays"
								/>
								<base:button 
									subclass="leftaligned"
									onclick="removeBioAssaysOnClick()" 
									title="Remove" 
									tooltip="Remove the selected bioassays"
								/>
							</base:buttongroup>
						</td>
						</tr>
						</table>
					</div>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Extra value type</th>
				<td>
					<base:select 
						id="parameter:extraValueType"
						clazz="selectionlist"
						required="true"
						current="<%=currentExtraValueType%>"
						recent="<%=recentExtraValueTypes%>"
						newitem="true"
						onselect="selectExtraValueTypeOnClick()"
					/>
				</td>
				<td></td>
			</tr>
			
			<tr>
				<th>Expression</th>
				<td>
					<select name="presets" style="width: 30em;"
						onchange="presetOnChange(this, this.form['parameter:expression'])" 
						>
						<option value="">- select from list or enter formula below -
						<%=formulaOptions.toString()%>
					</select>
				</td>
				<td></td>
			</tr>
			
			<tr class="big">
				<th class="subprompt"></th>
				<td>
					<textarea class="text required" name="parameter:expression" 
							rows="3" ><%=HTML.encodeTags(expression)%></textarea>
				</td>
				<td style="width: 20px;">
					<base:icon onclick="openExpressionBuilder()" 
						image="expression_builder.png"
						tooltip="A simple utility for building expressions"
					/>
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="doNext();" title="Next" />
			<base:button onclick="doCancel();" title="Cancel" />
		</base:buttongroup>
	
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}%>
