<%-- $Id: jep_filter.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	BioArray Software Environment (BASE) - http:// base.thep.lu.se/

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataProperty"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.WebException"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%!
private static void addFormulaOption(StringBuilder options, String formula, String title, String description)
{
	options.append("<option value=\"").append(HTML.encodeTags(formula)).append("\"");
	options.append(" title=\"").append(HTML.encodeTags(description)).append("\"");
	options.append(">").append(HTML.encodeTags(title)).append("\n");
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
ItemContext cc = sc.getCurrentContext(Item.BIOASSAYSET);
DbControl dc = null;

try
{
	String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
	List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");
	
	dc = sc.newDbControl();
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job, false);
	BioAssaySet source = null;
	source = (BioAssaySet)job.getParameterValue("source");
	if (source == null && cc.getId() != 0) source = BioAssaySet.getById(dc, cc.getId());
	if (source == null) throw new WebException("popup", "No current bioassay set", 
		"Could not find any current bioassay set. Please select a bioassay set before trying again");
	source = BioAssaySet.getById(dc, source.getId());
	RawDataType rdt = source.getRawDataType();
	long numBioAssays = source.getBioAssays().count(dc);
	int maxRawMappings = source.getMaxRawMappingsForSpot();
	
	// Find selected bioassays
	List<BioAssay> bioAssays = null;
	bioAssays = (List<BioAssay>)job.getParameterValues("bioAssays");
	if (bioAssays == null)
	{
		ItemContext bioAssayContext = sc.getCurrentContext(Item.BIOASSAY);
		ItemQuery<BioAssay> bioAssayQuery = null;
		if (bioAssayContext.getSelected().size() > 0)
		{
			bioAssayQuery = source.getBioAssays();
			bioAssayQuery.restrict(
				Restrictions.in(Hql.property("id"), Expressions.parameter("selected"))
			);
			bioAssayQuery.setParameter("selected", bioAssayContext.getSelected(), Type.INT);
			bioAssays = bioAssayQuery.list(dc);
		}
	}
	
	// Current parameter values
	String childName = Values.getString((String)job.getParameterValue("childName"), 
		source.getName().startsWith("Filtered") ? "" : "Filtered " + source.getName());
	String childDescription = (String)job.getParameterValue("childDescription");
	String expression = (String)job.getParameterValue("expression");
	Integer includeLimit = (Integer)job.getParameterValue("includeLimit");
	Integer excludeLimit = (Integer)job.getParameterValue("excludeLimit");
	
	// Predefined formulas
	ItemQuery<Formula> formulaQuery = Formula.getQuery(Formula.Type.COLUMN_RESTRICTION, rdt,
			source.getIntensityTransform());
	formulaQuery.order(Orders.asc(Hql.property("name")));
	formulaQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	ItemResultList<Formula> formulas = formulaQuery.list(dc);
	StringBuilder formulaOptions = new StringBuilder();
	for (Formula f : formulas)
	{
		String formula = f.getFormula(0);
		if (maxRawMappings == 1 || !formula.contains("raw("))
		{
			addFormulaOption(formulaOptions, formula, f.getName(), f.getDescription());
		}
	}
	%>
	<base:page type="popup" title="Filter bioassay set">
	<base:head scripts="linkitems.js" styles="parameters.css">
		<script language="JavaScript">
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}

		function presetOnChange(list, formula, label)
		{
			var index = list.selectedIndex;
			formula.value = list[index].value;
			if (list[index].value != '' && label) label.value = list[index].text;
		}
		function openExpressionBuilder()
		{
			Main.expressionBuilder('<%=ID%>', 'Expression', 'filter', 'parameter:expression', 'COLUMN_RESTRICTION', '<%=rdt.getId()%>', <%=rdt.getChannels()%>, true, <%=source.getId()%>);
		}
		function validate()
		{
			var frm = document.forms['filter'];
			var exclude = Main.trimString(frm['parameter:excludeLimit'].value);
			var include = Main.trimString(frm['parameter:includeLimit'].value);
			
			if (!frm.allBioAssays.checked && frm.bioAssays.length == 0)
			{
				alert('You have not selected any bioassays');
				return false;
			}
			else if (Main.trimString(frm['parameter:childName'].value) == '')
			{
				alert('You must enter a name for the child bioassay set');
				frm['parameter:name'].focus();
				return false;		
			}
			else if (Main.trimString(frm['parameter:expression'].value) == '')
			{
				alert('You must enter a filter expression');
				frm['parameter:expression'].focus();
				return false;
			}
			<%
			if (maxRawMappings != 1)
			{
				%>
				else if (frm['parameter:expression'].value.search(/raw\(/) != -1)
				{
					alert('Can\'t use function raw() for bioassayset with multiple mappings to raw data');
					frm['parameter:expression'].focus();
					return false;
				}
				<%
			}
			%>
			else if (exclude != '' || include != '')
			{
				exclude = parseInt(exclude);
				include = parseInt(include);
				
				if (include < 1 || include > <%=numBioAssays%>)
				{
					alert('The "include" value must be between 1 and <%=numBioAssays%>');
					frm['parameter:includeLimit'].focus();
					return false;
				}
				else if (exclude < 1 || exclude > <%=numBioAssays%>)
				{
					alert('The "exclude" value must be between 1 and <%=numBioAssays%>');
					frm['parameter:excludeLimit'].focus();
					return false;
				}
				else if (exclude > include)
				{
					alert('The "include" value can\'t be smaller than the "exclude" value.');
					return false;
				}
			}
			return true;
		}
		function doNext()
		{
			if (validate())
			{
				var frm = document.forms['filter'];
				if (!frm.allBioAssays.checked)
				{
					var ids = Link.getListIds(frm.bioAssays, 'R');
					for (var i = 0; i < ids.length; i++)
					{
						Forms.createHidden(frm, 'parameter:bioAssays', ids[i]);
					}
				}
				frm.submit();
			}
		}
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}

		function allBioAssaysOnClick()
		{
			var frm = document.forms['filter'];
			frm.bioAssays.disabled = frm.allBioAssays.checked;
		}

		function addBioAssaysOnClick()
		{
			var frm = document.forms['filter'];
			frm.allBioAssays.checked = false;
			frm.bioAssays.disabled = false;
			var ids = Link.getListIds(frm.bioAssays, 'R');
			var excludes = ids.join(',');
			var url = '../../views/experiments/bioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=addBioAssayCallback&bioassayset_id=<%=source.getId()%>';
			url += "&exclude="+excludes;
			Main.openPopup(url, 'AddBioAssays', 1050, 700);
		}
		function addBioAssayCallback(bioAssayId, name)
		{
			var item = Link.getItem('R', bioAssayId);
			if (!item) item = new Item('R', bioAssayId, name);
			Link.addItem(document.forms['filter'].bioAssays, item);
		}
		function removeBioAssaysOnClick()
		{
			var frm = document.forms['filter'];
			if (frm.allBioAssays.checked)
			{
				return;
			}
			Link.removeSelected(frm.bioAssays);
		}
		
		function init()
		{
			initBioAssays();
		}
		
		function initBioAssays()
		{
			var frm = document.forms['filter'];
			<%
			if (bioAssays != null)
			{
				for (BioAssay ba : bioAssays)
				{
					%>
					Link.addNewItem(frm.bioAssays, new Item('R', <%=ba.getId()%>, '<%=HTML.javaScriptEncode(ba.getName())%>'));
					<%
				}
			}
			%>
			frm.allBioAssays.checked = frm.bioAssays.length == 0;
			allBioAssaysOnClick();
		}
		</script>

	</base:head>
	<base:body onload="init()">
		<h1>Filter bioassay set <base:help helpid="jepfilter.options"/></h1>
		<form name="filter" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="parameter:source" value="<%=source.getId()%>">
		
		<div class="content bottomborder">
		<table class="fullform input100">
		<%
		if (errorMessage != null || (errors != null && errors.size() > 0))
		{
			%>
			<tr>
				<th></th>
				<td colspan="2">
				<div id="errors" style="margin-bottom: 12px;">
					<div class="messagecontainer error" style="margin: 0px;">
					<%=errorMessage %>
					<%
					if (errors != null && errors.size() > 0)
					{
						%>
						<div id="showerrorlist">
							<base:icon image="gonext.png" 
								onclick="showErrorList()" 
								style="color: #FFFFFF;"
								tooltip="Show more information about the error"
							/>
						</div>
						<div id="errorlist" style="display: none; margin: 0px;">
							<base:icon image="move_down.png" 
								onclick="hideErrorList()" 
								style="color: #FFFFFF;" 
								tooltip="Show less information"
							/>
							<ol>
							<%
							for (Throwable t : errors)
							{
								%>
								<li><%=t.getMessage()%>
								<%
							}
							%>
							</ol>
						</div>
						<%
					}
					%>
				</div>
				</td>
			</tr>
			<%
		}
		%>
		<tr>
			<th>Source</th>
			<td colspan="2"><%=HTML.encodeTags(source.getName())%></td>
		</tr>
		<tr class="big">
			<th class="subprompt">Bioassays</th>
			<td>
				<input type="checkbox" name="allBioAssays" id="allBioAssays"
					onclick="allBioAssaysOnClick()"><label for="allBioAssays">All bioassays</label><br>
				<div class="selectionlist">
					<table>
					<tr>
					<td>
						<select name="bioAssays" size="5" multiple>
						</select>
					</td>
					<td style="vertical-align: top;">
						<base:buttongroup vertical="true">
							<base:button 
								subclass="leftaligned"
								onclick="addBioAssaysOnClick()" 
								title="Add bioassays&hellip;" 
								tooltip="Add bioassays"
							/>
							<base:button 
								subclass="leftaligned"
								onclick="removeBioAssaysOnClick()" 
								title="Remove" 
								tooltip="Remove the selected bioassays"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
				</div>
			</td>
			<td></td>
		</tr>
		<tr>
			<th>Child bioassay set</th>
			<td colspan="2"></td>
		</tr>
		<tr>
			<th class="subprompt">Name</th>
			<td>
				<input type="text" class="text required" maxlength="255" 
					name="parameter:childName" 
					value="<%=HTML.encodeTags(childName)%>"></td>
			<td></td>
		</tr>
		<tr class="dynamic">
			<th class="subprompt">Description</th>
			<td>
				<textarea class="text" rows="3" name="parameter:childDescription" 
					><%=HTML.encodeTags(childDescription) %></textarea>
			</td>
			<td style="width: 20px;">
				<base:icon image="zoom.png" 
					onclick="Main.zoom('Description', 'filter', 'description')"
					tooltip="Edit in larger window"
				/>
			</td>
		</tr>

		<tr>
			<th>Filter</th>
			<td>
				<select name="presets" style="width: 30em;"
					onchange="presetOnChange(this, this.form['parameter:expression'])" 
					>
					<option value="">- select from list or enter formula below -
					<%=formulaOptions.toString()%>
				</select>
			</td>
			<td></td>
		</tr>
		<tr class="big">
			<th class="subprompt">Expression</th>
			<td>
				<textarea class="text required" name="parameter:expression" 
						rows="3" ><%=HTML.encodeTags(expression)%></textarea>
			</td>
			<td style="width: 20px;">
				<base:icon onclick="openExpressionBuilder()" 
					image="expression_builder.png"
					tooltip="A simple utility for building expressions"
				/>
			</td>
		</tr>
		<tr>
			<th class="subprompt">Keep</th>
			<td>Keep non-matching spots from all bioassays if the filter matches that spot in at least<br>
				<input class="text" type="text" name="parameter:includeLimit" style="width: 5em;"
					maxlength="10" value="<%=includeLimit == null ? "" : includeLimit.toString()%>"
					onkeypress="return Numbers.integerOnly(event)">
				bioassay(s) [1 - <%=numBioAssays%>]
			</td>
			<td></td>
		</tr>
		<tr>
			<th class="subprompt">Exclude</th>
			<td>Exclude matching spots from all bioassays if the filter doesn't match that spot in at least<br>
				<input class="text" type="text" name="parameter:excludeLimit"  style="width: 5em;"
					maxlength="10" value="<%=excludeLimit == null ? "" : excludeLimit.toString()%>"
					onkeypress="return Numbers.integerOnly(event)">
				bioassay(s) [1 - <%=numBioAssays%>]
			</td>
			<td></td>
		</tr>
		</table>
		</div>
		</form>
	
		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="doNext();" title="Next" />
			<base:button onclick="doCancel();" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

