<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json" 
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.SpecialQuery"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
	import="java.util.Date"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
DbControl dc = null;
try
{
	if ("GetExtracts".equals(cmd))
	{
		dc = sc.newDbControl();
		DerivedBioAssay dba = DerivedBioAssay.getById(dc, itemId);
		json.put("id", dba.getId());
		json.put("name", dba.getName());

		JSONArray jsonSources = new JSONArray();
		try
		{
			Extract extract = dba.getExtract();
			if (extract != null)
			{
				JSONObject jsonSrc = new JSONObject();
				jsonSrc.put("id", extract.getId());
				jsonSrc.put("name", extract.getName());
				jsonSources.add(jsonSrc);
			}
			else
			{
				SpecialQuery<BioMaterialEventSource> sourceQuery = dba.getPhysicalBioAssay().getCreationEvent().getEventSources();
				sourceQuery.order(Orders.asc(Hql.property("position")));
				sourceQuery.order(Orders.asc(Hql.property("bioMaterial.name")));
				for (BioMaterialEventSource src : sourceQuery.list(dc))
				{
					JSONObject jsonSrc = new JSONObject();
					try
					{
						extract = (Extract)src.getBioMaterial();
						jsonSrc.put("id", extract.getId());
						jsonSrc.put("name", extract.getName());
						jsonSrc.put("position", src.getPosition());
						jsonSources.add(jsonSrc);
					}
					catch (PermissionDeniedException ex)
					{}
				}
			}
		}
		catch (PermissionDeniedException ex)
		{}
		json.put("sources", jsonSources);

		
		dc.commit();
	}
	else if ("GetArrayDesign".equals(cmd))
	{
		dc = sc.newDbControl();
		try
		{
			DerivedBioAssay dba = DerivedBioAssay.getById(dc, itemId);
			ArrayDesign d = dba.getArrayDesign();
			if (d != null)
			{
				json.put("id", d.getId());
				json.put("name", d.getName());
				json.put("description", d.getDescription());
				json.put("numArrays", d.getNumArrays());
			}
		}
		catch (PermissionDeniedException pex)
		{}
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>