<%-- $Id: list.jsp 5952 2012-02-10 12:27:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.DynamicReporterQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.VirtualColumn"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Aggregations"
	import="net.sf.basedb.core.query.JoinType"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.List"
	import="java.util.LinkedList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.REPORTER;
%>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath();

final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final DbControl dc = sc.newDbControl();
DynamicResultIterator reporters = null;
long totalReporters = 0;
try
{
	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final RawDataType rawDataType = experiment.getRawDataType();
	
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	final ItemContext cc = explorer.getAndSetReporterContext(sc, null);
	final String subContext = cc.getSubContext();

	List<TableColumn> allColumns = new LinkedList<TableColumn>();
	DynamicUtil.addReporterColumns(allColumns, dc, experiment.getVirtualDb().getReporterCloneTemplate(), "", "@", "");
	
	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, allColumns, false);
	List<TableColumn> selectedColumns = selected.selectedColumns;
	
	try
	{
		DynamicReporterQuery reporterQuery = explorer.getReporterQuery(dc, selected.selectedProperties);
		reporterQuery.setFailSafe(true);
		totalReporters = explorer.getMatchingReporters(dc);
		reporters = reporterQuery.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	%>

	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js,newjoust.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,newjoust.css">
	<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'reporters';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, 'DEFAULT', viewItem, editItem, null);
		}		
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function viewReporter(index)
		{
			var url = '../view/index.jsp?ID=<%=ID%>&bioassayset_id=<%=bioAssaySetId%>';
			if (index >= 0)
			{
				url += '&cmd=SetReporterIndex&reporterIndex='+index;
			}
			location.href = url;
		}

		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'view')
			{
				viewReporter(-1);
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function newReporterList()
		{
			Table.submitToPopup(formId, 'CreateReporterList', 600, 400);
		}
	</script>
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Experiments" href="<%="../../index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" 
			/><p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+bioAssaySetId%>" 
			/><p:pathelement title="Explorer" /></p:path>
		<t:tabcontrol 
			id="explorer"
			subclass="mastertabcontrol content"
			switch="switchTab" remember="false" active="search">
		<t:tab id="search" title="Reporter search">
		<tbl:table 
			id="reporters" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<%
			for (TableColumn tc : allColumns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					clazz="<%="externalId".equals(tc.getId()) ? "uniquecol" : "columnheader"%>"
					property="<%=tc.getProperty()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=tc.getTitle()%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%=tc.getShow()%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
			<tbl:columndef 
				id="reporterList"
				property="£reporterList"
				datatype="int"
				title="Reporter list"
				filterable="true"
				enumeration="<%=Base.getReporterListsEnum(dc)%>"
				multiple="false"
			/>			
			
			<div class="panelgroup bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						image="add.png"
						onclick="newReporterList()"
						title="New reporter list&hellip;"
						tooltip="Create a new reporter list from matching reporters"
						visible="<%=sc.hasPermission(Permission.CREATE, Item.REPORTERLIST)%>"
					/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=totalReporters%>" 
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="icons"/>
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header clazz="icons"/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
			<%
			if (cc.getMessage() != null)
			{
				%>
				<tbl:panel clazz="messagepanel">
					<div class="messagecontainer error"><%=cc.getMessage()%></div>
				</tbl:panel>
				<%
				cc.setMessage(null);
			}
			int rowIndex = cc.getPage()*cc.getRowsPerPage();
			if (reporters != null)
			{
				while (reporters.hasNext())
				{
					SqlResult item = reporters.next();
					int itemId = item.getInt(1);
					rowIndex++;
					numListed++;
					%>
					<tbl:row>
						<tbl:header 
							clazz="icons"
							><a href="javascript:viewReporter(<%=rowIndex-1%>)"><%=rowIndex%></a></tbl:header>
						<%
						int colIndex = 2;
						for (TableColumn tc : selectedColumns)
						{
							String name = tc.getId();
							if ("externalId".equals(name))
							{
								%>
								<tbl:cell column="externalId"><div class="link" onclick="itemOnClick(event, <%=itemId%>)" 
									title="View this item (use CTRL, ALT or SHIFT to edit)"><%=HTML.encodeTags(item.getString(colIndex))%></div></tbl:cell>
								<%
							}
							else
							{
								%>
								<tbl:cell column="<%=name%>"><tbl:cellvalue value="<%=item.getObject(colIndex)%>" /></tbl:cell>
								<%
							}
							colIndex++;
						}
						%>
					</tbl:row>
					<%
				}
			}
			if (numListed == 0)
			{
				%>
				<tbl:panel clazz="messagepanel">
					<div class="messagecontainer note">
					<%=totalReporters == 0 ? "No reporters were found" : "No reporters on this page. Please select another page!" %>
					</div>
				</tbl:panel>
				<%
			}
			%>
			</tbl:rows>
			</tbl:data>
			</tbl:table>
		</t:tab>

		<t:tab id="view" title="Reporter view" />
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (reporters != null) reporters.close();
	if (dc != null) dc.close();
}

%>
