<%-- $Id: list_items.jsp 6068 2012-06-19 08:15:14Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Ownable"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.SYSTEM;
	private static final String subContext = "allitems";

	private static final Enumeration<String, String> items = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getOwnableItems())
		{
			items.add(item.name(), item.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final DbControl dc = sc.newDbControl();
ResultList<Ownable> allItems = null;
try
{
	long totalCount = 0;
	try
	{
		String filterItem = cc.getPropertyValue("type");
		Set<Item> itemTypes = null;
		if (filterItem != null)
		{
			itemTypes = new HashSet<Item>();
			for (String name : filterItem.split("\\|"))
			{
				itemTypes.add(Item.valueOf(name));
			}
		}
		Restriction sharedTo = cc.getFilterRestriction("!sharedTo.name", dc, null);
		Restriction name = cc.getFilterRestriction("name", dc, null);
		Restriction description = cc.getFilterRestriction("description", dc, null);
		Restriction id = cc.getFilterRestriction("id", dc, null);
		Restriction restriction = Restrictions.nullSafeAnd(sharedTo, name, description, id);
		if (sharedTo != null) 
		{
			// If we filter on "Shared to" we must make sure to only 
			// include Shareable items in the query
			if (itemTypes != null)
			{
				itemTypes.retainAll(Metadata.getShareableItems());
			}
			else
			{
				itemTypes = Metadata.getShareableItems();
			}
		}
		User loggedInUser = User.getById(dc, sc.getLoggedInUserId());
		if (itemTypes == null || itemTypes.size() > 0)
		{
			allItems = loggedInUser.getItems(itemTypes, cc.getPage() * cc.getRowsPerPage(), 
					cc.getRowsPerPage(), null, restriction);
		}
		totalCount = allItems.getTotalCount();
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext);
	ExtensionsInvoker invoker = ExtensionsControl.useExtensions(jspContext,  
			"net.sf.basedb.clients.web.toolbar.list.all", 
			"net.sf.basedb.clients.web.toolbar.list.allitems");
	%>
	<base:page title="All items">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'allItems';
		function itemOnClick(evt, itemId)
		{
			viewItem(itemId);
		}
		function deleteAllItems()
		{
			if (!confirm('You are about to PERMANENTLY DELETE all item.\n This can\'t be undone. Continue?'))
			{
				return;
			}
			var frm = document.forms[formId];
			frm.action = submitPage;
			frm.cmd.value = 'DeleteAllPermanently';
			frm.submit();
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			var numChecked = Forms.numChecked(frm, /item:/);
			if (numChecked == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm, /item:/) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemType, itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, itemType, itemId);
		}
		function shareItem(itemType, itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&&item_type='+itemType+'&item_id='+itemId, 'ShareItem', 600, 400);
		}
		function shareItems()
		{
			Table.shareItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'ShareItems', /item:/);
		}
		function setOwner()
		{
			Table.setOwnerOfItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'SetOwnerOfItems', /item:/);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		</script>
	</base:head>
	
	<base:body>
		<h1>All items</h1>
		<div class="content">
		<tbl:table 
			id="allItems" 
			columns="<%=cc.getSetting("columns")%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			subclass="fulltable"
			>
			<tbl:columndef
				id="type"
				property="type"
				datatype="string"
				title="Item type"
				enumeration="<%=items%>"
				filterable="true"
				show="always"
			/>
			<tbl:columndef 
				id="name"
				title="Name"
				property="name"
				filterable="true"
				datatype="string"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				property="id"
				datatype="int"
				title="ID"
				filterable="true"
			/>
			<tbl:columndef 
				id="description"
				title="Description"
				property="description"
				filterable="true"
				datatype="string"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<div class="panelgroup bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						image="delete.png"
						onclick="deleteItems()" 
						title="Delete" 
						tooltip="Mark the selected items for deletion" 
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						image="restore.png"
						onclick="restoreItems()" 
						title="Restore" 
						tooltip="Restore the selected items"
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						image="share.png"
						onclick="shareItems()" 
						title="Share&hellip;" 
						tooltip="Share the selected items"
						disabled="<%=totalCount <= 0%>"
					/>
					<tbl:button 
						image="take_ownership.png"
						onclick="setOwner()" 
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						image="columns.png" 
						onclick="configureColumns()" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector 
						onchange="presetOnChange()"
					/>
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=allItems == null ? 0 : allItems.getTotalCount()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<tbl:headerrow>
						<tbl:header subclass="index" />
						<tbl:header 
							subclass="check" 
							><base:icon 
								image="check_uncheck.png" 
								tooltip="Check/uncheck all" 
								onclick="Forms.checkUncheck(document.forms[formId], /item:/)" 
							/></tbl:header>
						<tbl:header 
							subclass="check" 
							visible="<%=mode.hasRadio()%>"
							/>
						<tbl:header 
							subclass="icons" 
							/>
						<tbl:propertyfilter />
					</tbl:headerrow>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					if (allItems != null)
					{
						for (Ownable item : allItems)
						{
							BasicItem basicItem = (BasicItem)item;
							boolean isRemoved = false;
							boolean isShared = false;
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							int itemId = item.getId();
							String openSharePopup = "shareItem('" + item.getType().name() + "', "+itemId+")";
							String deletePermanently = "deleteItemPermanently('" + item.getType().name() + "', "+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							String name = "";
							String description = "";
							if (item instanceof File)
							{
								File file = (File)item;
								name = file.getPath().toString();
								description = file.getDescription();
							}
							else if (item instanceof Directory)
							{
								Directory dir = (Directory)item;
								name = dir.getPath().toString();
								description = dir.getDescription();
							}
							else if (item instanceof Nameable)
							{
								Nameable nameable = (Nameable)item;
								name = nameable.getName();
								description = nameable.getDescription();
							}
							else
							{
								name = item.toString();
							}
							if (item instanceof Removable)
							{
								isRemoved = ((Removable)item).isRemoved();
							}
							if (item instanceof Shareable)
							{
								isShared = ((Shareable)item).isShared();
							}
							String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, true);
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="item:<%=item.getType().name()%>" 
										value="<%=itemId%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="deleted.png"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been marked for deletion" 
										visible="<%=isRemoved%>"
									/><base:icon 
										image="shared.png" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=isShared%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="type"><%=item.getType()%></tbl:cell>
								<tbl:cell column="name"><%=link%></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(description)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									if (item instanceof SharedItem)
									{
										Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, (SharedItem)item).iterator();
										while(sharees.hasNext())
										{
											Nameable n = sharees.next();
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(n.getName()));
											}
											out.write(sharees.hasNext() ? ", " : "");
										}
									}
									%>
								</tbl:cell>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel clazz="messagepanel">
							<div class="messagecontainer note">
							<%=allItems == null || allItems.size() == 0 ? "No items were found" : "No items on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
