<%-- $Id: edit_spotimages.jsp 5949 2012-02-08 14:35:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.SpotImages"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.RAWBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = "Create spot images";
	RawBioAssay rawBioAssay = RawBioAssay.getById(dc, itemId);
	SpotImages spi = rawBioAssay.getSpotImages();

	if (!rawBioAssay.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	boolean readRedImageFile = true;
	boolean readGreenImageFile = true;
	boolean readBlueImageFile = true;
	boolean readSpotImagesFile = true;
	File redImageFile = null;
	File greenImageFile = null;
	File blueImageFile = null;
	File spotImagesFile = null;
	try
	{
		redImageFile = spi.getRedImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readRedImageFile = false;
	}
	try
	{
		greenImageFile = spi.getGreenImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readGreenImageFile = false;
	}
	try
	{
		blueImageFile = spi.getBlueImageFile();
	}
	catch (PermissionDeniedException ex)
	{
		readBlueImageFile = false;
	}
	try
	{
		spotImagesFile = spi.getSpotImagesFile();
	}
	catch (PermissionDeniedException ex)
	{
		readSpotImagesFile = false;
	}
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "RawBioAssay" tab
		function validateSpotImages()
		{
			var frm = document.forms['spotimages'];
			
			return true;
		}
		function selectRedFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setRedFileCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemSubtype=<%=SystemItems.getId(File.IMAGE)%>';
			if (frm.redfile_id.length > 1) url += '&item_id='+frm.redfile_id[1].value;
			Main.openPopup(url, 'SelectRedFile', 1050, 700);
		}
		function setRedFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.redfile_id.length < 2) // >
			{
				frm.redfile_id[frm.redfile_id.length] = new Option();
			}
			frm.redfile_id[1].value = fileId;
			frm.redfile_id[1].text = name;
			frm.redfile_id.selectedIndex = 1;
		}

		function selectGreenFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setGreenFileCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemSubtype=<%=SystemItems.getId(File.IMAGE)%>';
			if (frm.greenfile_id.length > 1) url += '&item_id='+frm.greenfile_id[1].value;
			Main.openPopup(url, 'SelectGreenFile', 1050, 700);
		}
		function setGreenFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.greenfile_id.length < 2) // >
			{
				frm.greenfile_id[frm.greenfile_id.length] = new Option();
			}
			frm.greenfile_id[1].value = fileId;
			frm.greenfile_id[1].text = name;
			frm.greenfile_id.selectedIndex = 1;
		}
		
		function selectBlueFileOnClick()
		{
			var frm = document.forms['spotimages'];
			var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setBlueFileCallback';
			url += '&resetTemporary=1&tmpfilter:INT:itemSubtype=<%=SystemItems.getId(File.IMAGE)%>';
			if (frm.bluefile_id.length > 1) url += '&item_id='+frm.bluefile_id[1].value;
			Main.openPopup(url, 'SelectBlueFile', 1050, 700);
		}
		function setBlueFileCallback(fileId, name)
		{
			var frm = document.forms['spotimages'];
			if (frm.bluefile_id.length < 2) // >
			{
				frm.bluefile_id[frm.bluefile_id.length] = new Option();
			}
			frm.bluefile_id[1].value = fileId;
			frm.bluefile_id[1].text = name;
			frm.bluefile_id.selectedIndex = 1;
		}

		function browseOnClick()
		{
			Main.openPopup('../../filemanager/index.jsp?ID=<%=ID%>&cmd=SaveAs&callback=setSaveAsCallback', 'SaveAs', 1050, 700);
		}
		function setSaveAsCallback(path)
		{
			var frm = document.forms['spotimages'];
			frm.path.value = path;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['spotimages'];
			frm.submit();
		}
		</script>
	</base:head>
	<base:body>
		<h1><%=title%> <base:help helpid="rawbioassay.edit.spotimages" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="spotimages" onsubmit="return false;">
		<input type="hidden" name="item_id" value="<%=itemId%>">
		<input type="hidden" name="cmd" value="CreateSpotImages">

		<div class="content filled bottomborder">
			<table class="fullform input100">
			<tbody class="sectionheader">
				<tr>
					<th colspan="4">Scale, offset, etc. for the spots</th>
				</tr>
			</tbody>
			<tbody>
			<tr>
				<th>X scale</th>
				<td><input type="text" <%=requiredClazz%> name="x_scale" style="width: 8em;"
					value="<%=spi.getXScale()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<th class="leftborder">Y scale</th>
				<td><input type="text" <%=requiredClazz%> name="y_scale" style="width: 8em;"
					value="<%=spi.getYScale()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<th>X offset</th>
				<td><input type="text" <%=requiredClazz%> name="x_offset" style="width: 8em;"
					value="<%=spi.getXOffset()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<th class="leftborder">Y offset</th>
				<td><input type="text" <%=requiredClazz%> name="y_offset" style="width: 8em;"
					value="<%=spi.getYOffset()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<th>Spot size</th>
				<td><input type="text" <%=requiredClazz%> name="spotsize" style="width: 8em;"
					value="<%=spi.getSpotsize()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>

				<th class="leftborder">Gamma correction</th>
				<td><input type="text" <%=requiredClazz%> name="gamma" style="width: 8em;"
					value="<%=spi.getGamma()%>" maxlength="10" 
					onkeypress="return Numbers.numberOnly(event)"></td>
			</tr>
			<tr>
				<th>Quality</th>
				<td><input type="text" <%=requiredClazz%> name="quality" style="width: 8em;"
					value="<%=spi.getQuality()%>" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
				<th class="leftborder"></th>
				<td></td>
			</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th colspan="4">Raw image files</th>
				</tr>
			</tbody>
			<tbody>
			<tr>
				<th>Red image file</th>
				<td colspan="3">
					<table>
					<tr>
					<td>
						<select name="redfile_id" style="width: 25em;">
							<option value="0">- none -
							<%
							if (redImageFile != null)
							{
								%>
								<option value="<%=redImageFile.getId()%>" selected><%=HTML.encodeTags(redImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
					</td>
					<td><base:button onclick="selectRedFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<th>Green image file</th>
				<td colspan="3">
					<table>
					<tr>
					<td>
						<select name="greenfile_id" style="width: 25em;">
							<option value="0">- none -
							<%
							if (greenImageFile != null)
							{
								%>
								<option value="<%=greenImageFile.getId()%>" selected><%=HTML.encodeTags(greenImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
					</td>
					<td><base:button onclick="selectGreenFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>

			<tr>
				<th>Blue image file</th>
				<td colspan="3">
					<table>
					<tr>
					<td>
						<select name="bluefile_id" style="width: 25em;">
							<option value="0">- none -
							<%
							if (blueImageFile != null)
							{
								%>
								<option value="<%=blueImageFile.getId()%>" selected><%=HTML.encodeTags(blueImageFile.getPath().toString())%>
								<%
							}
							%>
						</select>
					</td>
					<td><base:button onclick="selectBlueFileOnClick()" title="Select&hellip;" /></td>
					</tr>
					</table>
				</td>
			</tr>
			
			<tr >
				<th>Save as</th>
				<td colspan="3">
					<table style="width: 100%;">
					<tr>
					<td style="width: 98%;"><input type="text" class="text required" 
						name="path" 
						value="<%=spotImagesFile == null ? "" : HTML.encodeTags(spotImagesFile.getPath().toString())%>"></td>
					<td ><base:button 
							title="Browse..."
							onclick="browseOnClick()"
							/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<th class="subprompt"></th>
				<td colspan="3"><input type="checkbox" name="overwrite" id="overwrite" value="1"><label for="overwrite">Overwrite existing file</label></td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td colspan="3"></td>
			</tr>
			</tbody>
			</table>
		</div>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button onclick="saveSettings()" title="Create" image="ok.png"/>
			<base:button onclick="window.close()" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
